package com.jetbyte.cache2;

import org.omg.CORBA.ORB;

import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContext;
import org.omg.CosNaming.NamingContextHelper;

import java.util.Properties;

public class Client 
{
   public static void main(String args[]) 
   {
      try
      {
         // initialize the ORB.

         ORB orb = ORB.init(args, null);

         org.omg.CORBA.Object obj = GetObjectFromName(orb, "JetByte Test", "CacheTest");

         CacheTest test = CacheTestHelper.narrow(obj);

         String sql = "Select * from myTable where 1 = 2";

         if (args.length > 0)
         {
            sql = args[0];
         }
   
         String[][] results = test.DoSelect(sql);
         
         for (int i = 0; i < results.length; ++i)
         {
            String line = "";

            for (int y = 0; y < results[i].length; ++y)
            {
               line += results[i][y] + " - ";
            }
            
            System.out.println(line);
         }
      }
      catch( Exception e )
      {
         e.printStackTrace(System.out);
      }
   }

   private static org.omg.CORBA.Object GetObjectFromName(
      ORB orb, 
      String contextName,
      String objectName) throws Exception
   {
      org.omg.CORBA.Object obj = orb.resolve_initial_references("NameService");

      NamingContext nc = NamingContextHelper.narrow(obj);

      if (nc == null) 
      {
         throw new Exception("Failed to narrow the root naming context.");
      }

      NameComponent[] name = new NameComponent[2];
      name[0] = new NameComponent(contextName, "JetByte Context"); 
      name[1] = new NameComponent(objectName, "Object"); 
	
      return nc.resolve(name);
   }
}

